function Crop(op) {
    var o = op || {};
    this.ctx = o.ctx || ctx;
    this.x = o.x || 0;
    this.y = o.y || 220;
    this.vx = 0;
    this.vy = 0;
    this.width = 50;
    this.height = 100;
    this.img = o.image[0] || (new Image());
    this.imgDead = o.image[1] || (new Image());

    this.type = o.type || 0;
    this.state = 0;
    this.chance = 0.5;
    this.currentTime = 0;
    this.collectable = false;
    this.deletable = false;
};
Crop.prototype.increaseChance = function(perc) {
    var p = perc || 0.5;
    this.chance += (1-this.chance) * p;

    if (this.chance > 1) {
        this.chance = 1;
    }

    console.log("Chance of growth increased to " + this.chance*100 + '%');
};
Crop.prototype.grow = function() {
    this.currentTime++;

    var evolve = false;
    if (this.state === 0) {
        if (this.type === 0) {
            if (this.currentTime >= 1) {
                evolve = true;
            }
        } else if (this.type === 1) {
            if (this.currentTime >= 2) {
                evolve = true;
            }
        } else if (this.type === 2) {
            if (this.currentTime >= 6) {
                evolve = true;
            }
        }
    } else if ((this.state == 1) && (this.currentTime > 11)) { //2 years after it's been harvested, spoil them
        this.state = -1;
    }

    if (evolve) {
        this.currentTime = 10;
        if (Math.random() < this.chance) {
            this.state = 1;    
        } else {
            this.state = -1;
        }
    }
};
Crop.prototype.chop = function() {
    if (this.state === 1) {
        this.vx = Math.random() * 0.5 - 0.25;
        this.vy = -1;
        this.y = 180;
        this.state = 2;
    } else if (this.state === -1) {
        this.deletable = true;
    }
};
Crop.prototype.render = function(ct){
    var ctx = ct || this.ctx || false;

    if (this.state === 2) {
        this.vy += 0.1;

        this.x += this.vx * 16; //fake delta
        this.y += this.vy * 16; //fake delta

        if (this.y > 220) {
            this.y = 220;
            if (this.collectable) {
                this.vx = 0;
                this.vy = 0;
            } else {
                this.vx = this.vx / 2;
                this.vy = -0.5;
                this.collectable = true;
            }
        }
    }

    if (ctx) {
        ctx.save();
            ctx.translate(this.x, this.y);

            if (this.type === 2) {
                ctx.fillStyle = "#5ca14d";
            } else if (this.type === 1) {
                ctx.fillStyle = "#fffe42";
            } else {
                ctx.fillStyle = "#cda267";
            }

            if (this.state === 0) {
                ctx.fillRect(-4,-4,8,8);
            } else if (this.state === 1) {
                //ctx.fillRect(-this.width/2, -this.height, this.width, this.height);
                ctx.drawImage(this.img, 0, 0, 14, 25, -this.width/2, -this.height, this.width, this.height);
            } else if (this.state === 2) {
                //ctx.fillRect(-this.width/2, -30, this.width, 30);
                ctx.drawImage(this.img, 0, 25, 14, 50, -this.width/2, -this.height/2, this.width, this.height);
            } else {
                ctx.fillStyle = '#888';
                //ctx.fillRect(-this.width/2, -this.height*0.8, this.width, this.height-(this.height*0.2));
                ctx.drawImage(this.imgDead, -this.width/2, -this.height, this.width, this.height);
            }
        ctx.restore();
    } else {
        console.log('No context specified in the update for:');
        console.log(this);
    }
};