function Farmer(op) {
    var o = op || {};
    this.ctx = o.ctx || ctx;
    this.x = o.x || 0;
    this.y = o.y || 0;
    this.vx = o.vx || 0;
    this.vy = o.vy || 0;
    this.width = o.width || 80;
    this.height = o.height || 88;

    this.animCounter = 0;
    this.img = o.image || (new Image());
    this.mask = o.mask || (new Image());

    this.otherImgs = o.otherImages || [];
    
    this.age = o.age || 0;
    this.item = o.item || false;

    this.actioning = o.actioning || false;
    this.stats = [0,0,0];

    this.sfxStep = o.sfx[0];
};
Farmer.prototype.action = function(){
    var that = this;
    
    if (!that.actioning) {
        that.actioning = true;

        if (that.item) {
            that.item.action();
        }

        setTimeout(function(){
            that.actioning = false;
        }, 300);
    }
};
Farmer.prototype.growUp = function() {
    this.age++;

    if (this.age >= 13) {
        this.mask = this.otherImgs[1];
    }
}
Farmer.prototype.update = function(d){
    var delta = d || dt || 1;
    this.animCounter += Math.abs(this.vx) * delta;

    this.x += this.vx * delta;
    this.y += this.vy * delta;

    if (this.x < this.width/2) {
        this.x = this.width/2;
    } else if (this.x > landWidth - this.width/2) {
        this.x = landWidth - this.width/2;
    }
};
Farmer.prototype.render = function(ct){
    var ctx = ct || this.ctx || false;

    if (ctx) {
        ctx.save();
            ctx.translate(this.x, this.y);
            
            var spriteFrame = 0;
            
            if (this.item && !this.actioning) {
                spriteFrame = 3;
            }

            var maskPos = 0;
            if (this.vx > 0.1 || this.vx < -0.1) {
                spriteFrame = 1;

                if (this.animCounter > 30 && this.animCounter <= 60) {
                    spriteFrame = 2;
                    maskPos = 4;
                } else if (this.animCounter > 60) {
                    this.animCounter = 0;

                    this.sfxStep.play(0.8 + Math.random()*0.4);
                }
            }

            if (this.vx < 0) {
                ctx.scale(-1, 1);
            }

            if (this.age < 4) {
                ctx.drawImage(this.otherImgs[0], -this.width/2, -this.height/2 + maskPos, this.width, this.height);
                //shadow
                if (this.vx < 0) {
                    ctx.scale(-1,1);
                }
                ctx.fillStyle = "rgba(0,0,0,0.4)";
                ctx.fillRect(-20, this.height/2, 28, 4);
            } else {
                ctx.drawImage(this.img, 0, spriteFrame * 22, 20, 22, -this.width/2, -this.height/2, this.width, this.height);
                ctx.drawImage(this.mask, -this.width/2, -this.height/2 + maskPos, this.width, this.height);

                if (this.item) {
                    this.item.render();
                }

                //shadow
                if (this.vx < 0) {
                    ctx.scale(-1,1);
                }
                ctx.fillStyle = "rgba(0,0,0,0.4)";
                ctx.fillRect(-30, this.height/2, 48, 4);
                ctx.fillRect(-26, this.height/2+4, 40, 4);
            }
        ctx.restore();
    } else {
        console.log('No context specified in the update for:');
        console.log(this);
    }
};