function Tool(op) {
    var o = op || {};
    this.ctx = o.ctx || ctx;
    this.x = o.x || 0;
    this.y = o.y || 0;
    this.width = o.width || 80;
    this.height = o.height || 88;
    this.sWidth = o.sWidth || 20;  //original sprite width (1 cell)
    this.sHeight = o.sHeight || 22; //original sprite height (1 cell)
    this.img = o.image || (new Image());

    this.type = o.type || 0;
    this.typeImage = o.typeImage || [];

    this.direction = o.direction || 1;
    this.actioning = o.actioning || false;
    this.actionFunc = o.action || function(){};

    this.speed = o.speed || 1;
    this.auto = o.auto || false;
    this.points = o.points || 1;
};
Tool.prototype.action = function(){
    var that = this;
    
    if (!that.actioning) {
        that.actioning = true;
        that.actionFunc();

        setTimeout(function(){
            that.actioning = false;
        }, 300);
    }
};
Tool.prototype.render = function(ct){
    var ctx = ct || this.ctx || false;

    if (ctx) {
        ctx.save();
            ctx.translate(this.x, this.y);
            var spriteFrame = 0;
            if (this.actioning) {
                spriteFrame = 1;
            }
            ctx.drawImage(this.img, 0, spriteFrame * 22, 20, 22, -this.width/2, -this.height/2, this.width, this.height);

            if (this.typeImage.length) {
                ctx.drawImage(this.typeImage[this.type], -this.width/2, -this.height/2, this.width, this.height);
            }
        ctx.restore();
    } else {
        console.log('No context specified in the update for:');
        console.log(this);
    }
};